"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const cache_1 = require("@dandi/cache");
const core_1 = require("@dandi/core");
const mvc_1 = require("@dandi/mvc");
const admin = require("firebase-admin");
const luxon_1 = require("luxon");
const firebase_service_account_1 = require("./firebase.service.account");
let FirebaseAuthorizationService = class FirebaseAuthorizationService {
    constructor(serviceAccount, cache, cacheKey) {
        this.cache = cache;
        this.cacheKey = cacheKey;
        this.app = admin.initializeApp({
            credential: admin.credential.cert(serviceAccount),
        });
    }
    get auth() {
        return this.app.auth();
    }
    async getAuthorizedUser(authorization) {
        const tokenStr = authorization.substring(authorization.indexOf(' ') + 1);
        const userKey = this.cacheKey.keyFor(tokenStr);
        let user = await this.cache.get(userKey);
        if (user) {
            return user;
        }
        const token = await this.auth.verifyIdToken(tokenStr, true);
        const expires = luxon_1.DateTime.fromMillis(token.exp * 1000);
        user = await this.auth.getUser(token.uid);
        this.cache.set(userKey, user, expires.diffNow());
        return user;
    }
};
FirebaseAuthorizationService = __decorate([
    core_1.Injectable(mvc_1.AuthorizationService('Bearer'), core_1.Singleton),
    __param(0, core_1.Inject(firebase_service_account_1.FirebaseServiceAccount)),
    __param(1, core_1.Inject(cache_1.Cache)),
    __param(2, core_1.Inject(cache_1.CacheKeyGenerator)),
    __metadata("design:paramtypes", [firebase_service_account_1.FirebaseServiceAccount, Object, Object])
], FirebaseAuthorizationService);
exports.FirebaseAuthorizationService = FirebaseAuthorizationService;
//# sourceMappingURL=firebase.authorization.service.js.map